<template>
  <!--suppress CheckEmptyScriptTag -->
  <svg
    :id="htmlId.replace('#','')"
    width="600"
    height="300"
  />
</template>

<script>
  import moment from 'moment-timezone'
  const d3 = require('d3')

  export default {
    name: 'MetrocheckFrequencyChart',

    props: {
      chartData: { type: Array, required: true },
      id: { type: String, required: true },
    },

    data: function () {
      return {
        height: 300,
        width: 600,
        margin: ({ top: 30, right: 0, bottom: 30, left: 40 }),
        color: 'steelblue',
      }
    },

    computed: {
      htmlId: function () {
        return `#js-frequency-chart-${this.$props.id}`
      },
    },

    watch: {
      chartData: function (newData) {
        console.debug('FrequencyChart data changed')
        console.debug(this.$props.chartData, newData)
        // eslint-disable-next-line no-debugger
        debugger
        d3.select(this.htmlId).html('')
        this.drawChart(newData)
      },
    },

    mounted: function () {
      console.debug('FrequencyChart mounted')
      console.debug(d3.select(this.htmlId))
      console.debug(d3.select('svg'))
      d3.select(this.htmlId)
        .attr('viewBox', [0, 0, this.width, this.height])

      this.drawChart()
    },

    methods: {

      drawChart: function () {
        if (!this.$props.chartData) { console.debug('Frequency chart : no data supplied'); console.trace(); return false }
        // const getTime = d => d.datetime
        const minDate = moment.utc(this.$props.chartData[0].datetime).toDate()
        const maxDate = moment.utc(this.$props.chartData[this.$props.chartData.length - 1].datetime).toDate()

        console.debug('Drawing chart with boundaries : %O, %O. %O items', minDate, maxDate, this.$props.chartData.length)

        const xScale = d3.scaleTime()
          .domain([minDate, maxDate])
          .rangeRound([this.margin.left, this.width - this.margin.right])

        const yScale = d3.scaleLinear()
          .domain([0, d3.max(this.$props.chartData, d => d.value)])
          .rangeRound([this.height - this.margin.bottom, this.margin.top])

        const svg = d3.select(this.htmlId)

        svg.append('g')
          .attr('fill', this.color)
          .selectAll('rect')
          .data(this.$props.chartData)
          .join('rect')
          .attr('x', d => xScale(moment.utc(d.datetime).toDate()))
          .attr('y', d => yScale(d.value))
          .attr('height', d => yScale(0) - yScale(d.value))
          .attr('width', Math.floor(this.width / this.$props.chartData.length))

        svg.append('g')
          .call(this.xAxis(xScale))

        svg.append('g')
          .call(this.yAxis(yScale))
      },

      xAxis: function (x) {
        return g => g
          .attr('transform', `translate(0,${this.height - this.margin.bottom})`)
          .call(d3.axisBottom(x).ticks(10).tickFormat(d3.timeFormat('%H:%M')))
          // .call(d3.axisBottom(x).tickValues((d3.timeMinute.every(15))))
          // .tickFormat(i => this.$props.chartData[i].datetime).tickSizeOuter(0))
      },

      yAxis: function (y) {
        return g => g
          .attr('transform', `translate(${this.margin.left},0)`)
          .call(d3.axisLeft(y).ticks(null, this.$props.chartData.format))
          .call(g => g.select('.domain').remove())
          .call(g => g.append('text')
            .attr('x', -this.margin.left)
            .attr('y', 10)
            .attr('fill', 'currentColor')
            .attr('text-anchor', 'start')
            .text('count'))
      },
    },
  }
</script>

<style scoped>
#js-frequency-chart {
  width: 100%;
}
</style>
